diff --git a/gnu/packages/xfce.scm b/gnu/packages/xfce.scm
index 2f6041cc9b..bed445fb23 100644
--- a/gnu/packages/xfce.scm
+++ b/gnu/packages/xfce.scm
@@ -141,7 +141,8 @@ (define-public libxfce4util
     (description
      "A general-purpose utility library with core application support for the
 Xfce Desktop Environment.")
-    (license lgpl2.0+)))
+    (license lgpl2.0+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfconf
   (package
@@ -183,7 +184,8 @@ (define-public xfconf
     (description
      "Settings daemon for Xfce, implemented as a D-Bus-based configuration
 storage system.")
-    (license lgpl2.0+)))
+    (license lgpl2.0+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public libxfce4ui
   (package
@@ -216,7 +218,8 @@ (define-public libxfce4ui
     (description
      "Libxfce4ui is the replacement of the old libxfcegui4 library.  It is used
 to share commonly used Xfce widgets among the Xfce applications.")
-    (license lgpl2.0+)))
+    (license lgpl2.0+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public catfish
   (package
@@ -269,7 +272,8 @@ (define-public catfish
      "Catfish is a file searching tool for Linux and Unix.  The interface is
 intentionally lightweight and simple, using only GTK+ 3.  You can configure
 it to your needs by using several command line options.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public elementary-xfce-icon-theme
   (package
@@ -336,7 +340,8 @@ (define-public exo
 that are targeted at desktop development, libexo is targeted at application
 development.")
     ;; Libraries are under LGPLv2+, and programs under GPLv2+.
-    (license (list gpl2+ lgpl2.1+))))
+    (license (list gpl2+ lgpl2.1+))
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public garcon
   (package
@@ -368,7 +373,9 @@ (define-public garcon
 GLib and GIO.  It was started as a complete rewrite of the former Xfce menu
 library called libxfce4menu, which, in contrast to garcon, was lacking menu
 merging features essential for loading menus modified with menu editors.")
-    (license lgpl2.0+)))
+    (license lgpl2.0+)
+    ;; FIXME: the 'generic-git' updater treat "rc" as pre-releases.
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public tumbler
   (package
@@ -403,7 +410,8 @@ (define-public tumbler
      "Tumbler is a D-Bus service for applications to request thumbnails for
 various URI schemes and MIME types.  It is an implementation of the thumbnail
 management D-Bus specification.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public libxfce4windowing
   (package
@@ -436,7 +444,8 @@ (define-public libxfce4windowing
      "Libxfce4windowing is an abstraction library that attempts to present
 windowing concepts (screens, toplevel windows, workspaces, etc.) in a
 windowing-system-independent manner.")
-    (license lgpl2.1+)))
+    (license lgpl2.1+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-panel
   (package
@@ -484,7 +493,8 @@ (define-public xfce4-panel
      "Desktop panel for Xfce, which contains program launchers, window buttons,
 applications menu, workspace switcher and more.")
     ;; Libraries are under LGPLv2.1+, and programs under GPLv2+.
-    (license (list gpl2+ lgpl2.1+))))
+    (license (list gpl2+ lgpl2.1+))
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-battery-plugin
   (package
@@ -511,7 +521,8 @@ (define-public xfce4-battery-plugin
      "A battery monitor panel plugin for Xfce4, compatible with APM and ACPI.")
     ;; The main plugin code is covered by gpl2+, but the files containing code
     ;; to read the battery state via ACPI or APM are covered by lgpl2.0+.
-    (license (list gpl2+ lgpl2.0+))))
+    (license (list gpl2+ lgpl2.0+))
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-clipman-plugin
   (package
@@ -539,7 +550,8 @@ (define-public xfce4-clipman-plugin
 around while it is usually lost when you close an application.  It is able to
 handle text and images, and has a feature to execute actions on specific text by
 matching them against regular expressions.")
-    (license (list gpl2+))))
+    (license (list gpl2+))
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-pulseaudio-plugin
   (package
@@ -576,7 +588,8 @@ (define-public xfce4-pulseaudio-plugin
 convenient way to adjust the audio volume of the PulseAudio sound system and
 to an auto mixer tool like pavucontrol.  It can optionally handle multimedia
 keys for controlling the audio volume.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-whiskermenu-plugin
   (package
@@ -651,7 +664,8 @@ (define-public xfce4-xkb-plugin
 flag image or text) and the layout policy, which is whether to
 store the layout globally (for all windows), per application or
 per window.")
-    (license bsd-2)))
+    (license bsd-2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-appfinder
   (package
@@ -679,7 +693,8 @@ (define-public xfce4-appfinder
     (description
      "Application finder for Xfce, it will show the applications installed on
 your system in categories, so you can quickly find and launch them.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-session
   (package
@@ -728,7 +743,8 @@ (define-public xfce4-session
     (description
      "Session manager for Xfce, it will restore your session on startup and
 allows you to shut down the computer from Xfce.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-settings
   (package
@@ -778,7 +794,8 @@ (define-public xfce4-settings
     (description
      "Settings manager for Xfce, it can control various aspects of the desktop
 like appearance, display, keyboard and mouse settings.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar
   (package
@@ -823,7 +840,8 @@ (define-public thunar
     (description
      "A modern file manager for graphical desktop, aiming to be easy-to-use and
 fast.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar-volman
   (package
@@ -851,7 +869,8 @@ (define-public thunar-volman
 thunar-volman is installed and configured properly, and you plug in your
 digital camera, it will automatically spawn your preferred photo application
 and import the new pictures from your camera.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar-archive-plugin
   (package
@@ -874,7 +893,9 @@ (define-public thunar-archive-plugin
     (synopsis "Archive plugin for Thunar file manager")
     (description "The Thunar Archive Plugin allows you to create and extract
 archive files using the file context menus in the Thunar file manager.")
-    (license gpl2+)))
+    (license gpl2+)
+    ;; FIXME: the 'generic-git' updater treat "rc" as pre-releases.
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar-shares-plugin
   (package
@@ -898,7 +919,8 @@ (define-public thunar-shares-plugin
     (description
      "The Thunar Shares Plugin allows you to quickly share a folder using
 Samba from Thunar (the Xfce file manager) without requiring root access.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar-media-tags-plugin
   (package
@@ -922,7 +944,8 @@ (define-public thunar-media-tags-plugin
     (description
      "Media tags plugin allows tags editing from Thunar file manager and
 tags-based file renaming from inside Thunar Bulk Renamer.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunar-vcs-plugin
   (package
@@ -960,7 +983,8 @@ (define-public thunar-vcs-plugin
      "Thunar VCS Plugin (formerly known as Thunar SVN Plugin) gives SVN and
 GIT integration to Thunar, it adds Subversion and GIT actions to the context
 menu.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public thunarx-python
   (package
@@ -990,7 +1014,8 @@ (define-public thunarx-python
     (synopsis "Python Bindings for Thunar")
     (description
      "These bindings allow one to create python plugins for Thunar.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfwm4
   (package
@@ -1024,7 +1049,8 @@ (define-public xfwm4
     (description
      "Window manager for Xfce, it handles the placement of windows
 on the screen.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfwm4-themes
   (package
@@ -1108,7 +1134,8 @@ (define-public xfdesktop
      "Desktop manager for Xfce, it sets the background color or image with
 optional application menu or icons for minimized applications or launchers,
 devices and folders.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public gigolo
   (package
@@ -1136,7 +1163,8 @@ (define-public gigolo
      "Gigolo is a graphical user interface to easily manage connections to
 remote file systems using GIO/GVfs.  It allows you to quickly connect/mount
 local and remote file systems and manage bookmarks of such.")
-    (license gpl2)))                              ;version 2 only
+    (license gpl2)                                ;version 2 only
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public parole
   (package
@@ -1184,7 +1212,8 @@ (define-public parole
     (description "Parole is a modern simple media player based on the
 GStreamer framework and written to fit well in the Xfce desktop.  Parole
 features playback of local media files, DVD/CD and live streams.")
-    (license gpl2)))                    ;version 2 only
+    (license gpl2)                      ;version 2 only
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-terminal
   (package
@@ -1217,7 +1246,8 @@ (define-public xfce4-terminal
 pseudo-transparent terminal background, and a compact mode (where both the
 menubar and the window decorations are hidden) that helps you to save space
 on your desktop.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-dict
   (package
@@ -1248,7 +1278,8 @@ (define-public xfce4-dict
 
 xfce4-dict contains a stand-alone application called “xfce4-dict” and a panel
 plugin for the Xfce panel.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfdashboard
   (package
@@ -1387,7 +1418,8 @@ (define-public xfce4-power-manager
 freedesktop-compliant DBus interfaces to inform other applications about current
 power level so that they can adjust their power consumption, and it provides the
 inhibit interface which allows applications to prevent automatic sleep.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public ristretto
   (package
@@ -1417,7 +1449,8 @@ (define-public ristretto
 and scroll through images.  It can be used to run a slideshow of images, open
 images with other applications like an image-editor or configure an image as
 the desktop wallpaper.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-taskmanager
   (package
@@ -1451,7 +1484,8 @@ (define-public xfce4-taskmanager
     (description
      "This is a task manager for the Xfce desktop.  It displays the CPU and
 memory usage graphically, and it can display processes as a tree.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public orage
   (package
@@ -1479,7 +1513,8 @@ (define-public orage
 calendar applications.  It also includes a panel clock plugin and an
 international clock application capable of simultaneously showing clocks from
 several different time zones.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-notifyd
   (package
@@ -1508,7 +1543,8 @@ (define-public xfce4-notifyd
 bubble in a standard way can implicitly make use of xfce4-notifyd to do so by
 sending standard messages over D-Bus using the
 @code{org.freedesktop.Notifications} interface.")
-    (license gpl2)))
+    (license gpl2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfburn
   (package
@@ -1547,7 +1583,8 @@ (define-public xfburn
 the libburnia libraries.  It can blank CD/DVD/BD(-RW)s, burn and
 create iso images, audio CDs, as well as burn personal compositions
 of data to either CD/DVD/BD.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public mousepad
   (package
@@ -1586,7 +1623,8 @@ (define-public mousepad
     (synopsis "Simple text editor for Xfce")
     (description
      "Mousepad is a graphical text editor for Xfce based on Leafpad.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-screenshooter
   (package
@@ -1613,7 +1651,8 @@ (define-public xfce4-screenshooter
 window or a selected region.  You can set the delay that elapses before the screenshot
 is taken and the action that will be done with the screenshot.
 A plugin for the Xfce panel is also available.")
-   (license gpl2+)))
+   (license gpl2+)
+   (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-screensaver
   (package
@@ -1657,7 +1696,8 @@ (define-public xfce4-screensaver
     (description
      "Xfce Screensaver is a screen saver and locker that aims to have simple,
  sane, secure defaults and be well integrated with the Xfce desktop.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-volumed-pulse
   (package
@@ -1682,7 +1722,8 @@ (define-public xfce4-volumed-pulse
     (description
      "This is a volume keys control daemon for Xfce Desktop environment. It controls
  the volume using multimedia keys. It also provides volume change notifications.")
-    (license gpl3+)))
+    (license gpl3+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-cpugraph-plugin
   (package
@@ -1713,7 +1754,8 @@ (define-public xfce4-cpugraph-plugin
 On multi core or multi CPU systems, CPU Graph can either track and
 display all of them at once, or at the user's option only a specific
 core or CPU.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-eyes-plugin
   (package
@@ -1738,7 +1780,8 @@ (define-public xfce4-eyes-plugin
     (synopsis "Display a pair of eyes for the Xfce panel")
     (description "Eyes is a toy Xfce panel plugin that adds eyes which
 watch your every step.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-datetime-plugin
   (package
@@ -1763,7 +1806,8 @@ (define-public xfce4-datetime-plugin
     (synopsis "Display date and time inside the Xfce panel")
     (description "This plugin shows the date and time in the panel,
 and a calendar appears when you left-click on it.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-calculator-plugin
   (package
@@ -1789,7 +1833,8 @@ (define-public xfce4-calculator-plugin
     (description "This plugin is a calculator for the Xfce4 panel.  It
 supports common mathematical operators (+, -, *, /, ^) with usual
 precedence rules, and the following functions and common constants.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-cpufreq-plugin
   (package
@@ -1814,7 +1859,8 @@ (define-public xfce4-cpufreq-plugin
     (synopsis "Xfce panel plugin for displaying CPU frequency")
     (description "This panel plugin shows information about the CPU
 governor and frequencies supported and used by your system.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-diskperf-plugin
   (package
@@ -1839,7 +1885,8 @@ (define-public xfce4-diskperf-plugin
     (synopsis "Display disk performance in the Xfce panel")
     (description "This Xfce panel plugin displays instant disk/partition
 performance (bytes transferred per second).")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-fsguard-plugin
   (package
@@ -1867,7 +1914,8 @@ (define-public xfce4-fsguard-plugin
 are two limits: a warning limit where only the icon changes, and an
 urgent limit that advise the user with a message.  The icon button can
 be clicked to open the chosen mount point.")
-    (license bsd-2)))
+    (license bsd-2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-genmon-plugin
   (package
@@ -1896,7 +1944,8 @@ (define-public xfce4-genmon-plugin
 
 The string can also contain markup to displayed an image, a bar, a
 button and a personalized tooltip.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-mailwatch-plugin
   (package
@@ -1930,7 +1979,8 @@ (define-public xfce4-mailwatch-plugin
 @item MH-Maildir mail spool (local)
 @item Google Mail (GMail) mailbox (remote) (requires gnutls)
 @end itemize")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-mpc-plugin
   (package
@@ -1972,7 +2022,8 @@ (define-public xfce4-mpc-plugin
 right-click menu
 @item configurable markup for tooltip and playlist, using a gmpc-like markup
 @end itemize")
-    (license isc)))
+    (license isc)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-mount-plugin
   (package
@@ -1999,7 +2050,8 @@ (define-public xfce4-mount-plugin
 your various devices.  If you click on an unmounted devices it will
 mount it and vice versa.  There is a warning in case a device can't be
 mounted or when unmounting fails.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-netload-plugin
   (package
@@ -2024,7 +2076,8 @@ (define-public xfce4-netload-plugin
     (synopsis "Netload plugin for the Xfce Panel")
     (description "This plugin displays the current load of the network
 interfaces of your choice in the panel.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-places-plugin
   (package
@@ -2061,7 +2114,8 @@ (define-public xfce4-places-plugin
 @item Search program launcher (optional)
 @item Recent documents submenu
 @end itemize")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-smartbookmark-plugin
   (package
@@ -2087,7 +2141,8 @@ (define-public xfce4-smartbookmark-plugin
     (description "This plugin allows you to send search requests
 directly to your browser, such that you can search through your
 favorite search engine or bug tracker right from the Xfce panel.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-statusnotifier-plugin
   (package
@@ -2140,7 +2195,8 @@ (define-public xfce4-stopwatch-plugin
     (home-page "https://docs.xfce.org/panel-plugins/xfce4-stopwatch-plugin/")
     (synopsis "Stopwatch plugin for the Xfce panel")
     (description "This Xfce panel plugin keeps track of elapsed time.")
-    (license bsd-2)))
+    (license bsd-2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-systemload-plugin
   (package
@@ -2166,7 +2222,8 @@ (define-public xfce4-systemload-plugin
     (description "A system load plugin for the Xfce4 desktop
 environment.  It displays the current CPU load, the memory in use, the
 swap space and the system uptime in the Xfce4 panel.")
-    (license bsd-2)))
+    (license bsd-2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-time-out-plugin
   (package
@@ -2193,7 +2250,8 @@ (define-public xfce4-time-out-plugin
 breaks from the computer every X minutes.  During breaks it locks your
 screen.  It optionally allows you to postpone breaks for a certain
 time.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-timer-plugin
   (package
@@ -2219,7 +2277,8 @@ (define-public xfce4-timer-plugin
     (description "This is a simple plugin that lets the user run an
 alarm at a specified time or at the end of a specified countdown
 period.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-verve-plugin
   (package
@@ -2251,7 +2310,8 @@ (define-public xfce4-verve-plugin
 @item Focus grabbing via D-BUS (so you can bind a shortcut to it)
 @item Custom input field width
 @end itemize")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-wavelan-plugin
   (package
@@ -2276,7 +2336,8 @@ (define-public xfce4-wavelan-plugin
     (synopsis "Show stats from WLAN interface in Xfce panel")
     (description "This plugin is used to display stats from a wireless
 lan interface (signal state, signal quality, network name (SSID)).")
-    (license bsd-2)))
+    (license bsd-2)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-weather-plugin
   (package
@@ -2305,7 +2366,8 @@ (define-public xfce4-weather-plugin
     (description "This Xfce panel plugin shows information about your
 local weather in the panel, using forecast data provided by the
 @uref{https://met.no, Norwegian Meteorological Institute}.")
-    (license gpl2+)))
+    (license gpl2+)
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))
 
 (define-public xfce4-dev-tools
   (package
@@ -2354,4 +2416,6 @@ (define-public xfce4-dev-tools
      "The Xfce development tools are a collection of tools and macros for Xfce
 developers and people that want to build Xfce from Git In addition it contains
 the Xfce developer's handbook.")
-    (license gpl2+)))
+    (license gpl2+)
+    ;; FIXME: the 'generic-git' updater treat "dev" as pre-releases.
+    (properties `((release-tag-prefix . ,(string-append name "-"))))))