diff --git a/gnu/packages/matrix.scm b/gnu/packages/matrix.scm
index a65e3b0143..afdbcfc14c 100644
--- a/gnu/packages/matrix.scm
+++ b/gnu/packages/matrix.scm
@@ -214,69 +214,64 @@ (define-public python-matrix-nio
     (license license:isc)))
 
 (define-public pantalaimon
-  (package
-    (name "pantalaimon")
-    (version "0.10.5")
-    (source
-     (origin
-       (method git-fetch)
-       (uri (git-reference
-             (url "https://github.com/matrix-org/pantalaimon")
-             (commit version)))
-       (file-name (git-file-name name version))
-       (sha256
-        (base32
-         "16ask8v00654q307c55q5gnm8hrj40gibpab5zl52v4i0bgl9j68"))))
-    (build-system python-build-system)
-    (arguments
-     (list
-      #:phases
-      #~(modify-phases %standard-phases
-          (add-after 'unpack 'downgrade-appdirs-requirement
-            (lambda _
-              (substitute* "setup.py"
-                ;; FIXME: Remove this once appdirs is updated.
-                ;; Upgrading python-appdirs requires rebuilting 3000+ packages,
-                ;; when 1.4.4 is a simple maintenance fix from 1.4.3.
-                (("appdirs >= 1.4.4") "appdirs >= 1.4.3"))))
-          (add-after 'install 'install-doc
-            (lambda _
-              (with-directory-excursion "docs/man"
-                (let ((man (string-append #$output "/share/man")))
-                  (install-file "panctl.1" (string-append man "/man1"))
-                  (install-file "pantalaimon.5" (string-append man "/man5"))
-                  (install-file "pantalaimon.8" (string-append man "/man8"))))))
-          (replace 'check
-            (lambda* (#:key tests? inputs outputs #:allow-other-keys)
-              (when tests?
-                (add-installed-pythonpath inputs outputs)
-                (invoke "pytest" "-vv" "tests")))))))
-    (native-inputs
-     (list python-aioresponses
-           python-faker
-           python-pytest
-           python-pytest-aiohttp))
-    (propagated-inputs
-     (list python-aiohttp
-           python-appdirs
-           python-attrs
-           python-cachetools
-           python-click
-           python-dbus
-           python-janus
-           python-keyring
-           python-logbook
-           python-matrix-nio
-           python-notify2
-           python-peewee
-           python-prompt-toolkit
-           python-pydbus
-           python-pygobject))
-    (home-page "https://github.com/matrix-org/pantalaimon")
-    (synopsis "Matrix proxy daemon that adds E2E encryption capabilities")
-    (description
-     "Pantalaimon is an end-to-end encryption aware Matrix reverse proxy
+  (let ((commit "257ef6a2e5e5668cd43347037c09ba036f91d997")
+        (revision "0"))
+    (package
+      (name "pantalaimon")
+      (version (git-version "0.10.5" revision commit))
+      (source
+       (origin
+         (method git-fetch)
+         (uri (git-reference
+               (url "https://github.com/matrix-org/pantalaimon")
+               (commit commit)))
+         (file-name (git-file-name name version))
+         (sha256
+          (base32 "1i18mjlc143d2xwlha09i5ny06vipmy8fii05427zq5vjz8rysgx"))))
+      (build-system python-build-system)
+      (arguments
+       (list
+        #:phases
+        #~(modify-phases %standard-phases
+            (add-after 'install 'install-doc
+              (lambda _
+                (with-directory-excursion "docs/man"
+                  (let ((man (string-append #$output "/share/man")))
+                    (install-file "panctl.1" (string-append man "/man1"))
+                    (install-file "pantalaimon.5" (string-append man "/man5"))
+                    (install-file "pantalaimon.8" (string-append man "/man8"))))))
+            (replace 'check
+              (lambda* (#:key tests? inputs outputs #:allow-other-keys)
+                (when tests?
+                  (add-installed-pythonpath inputs outputs)
+                  (invoke "pytest" "-vv" "tests")))))))
+      (native-inputs
+       (list python-aioresponses
+             python-faker
+             python-pytest
+             python-pytest-aiohttp
+             python-pytest-asyncio))
+      (propagated-inputs
+       (list python-aiohttp
+             python-attrs
+             python-cachetools
+             python-click
+             python-dbus
+             python-janus
+             python-keyring
+             python-logbook
+             python-matrix-nio
+             python-notify2
+             python-peewee
+             python-platformdirs
+             python-prompt-toolkit
+             python-pydbus
+             python-pygobject))
+      (home-page "https://github.com/matrix-org/pantalaimon")
+      (synopsis "Matrix proxy daemon that adds E2E encryption capabilities")
+      (description
+       "Pantalaimon is an end-to-end encryption aware Matrix reverse proxy
 daemon.  Pantalaimon acts as a good man in the middle that handles the
 encryption for you.  Messages are transparently encrypted and decrypted for
 clients inside of pantalaimon.")
-    (license license:asl2.0)))
+      (license license:asl2.0))))